/*
 ****************** File CtrlCmpSc.h *************************
 *
 *  Definitions of user application interface
 *	structures and constants
 *	for BRD_ctrl : CmpSc section (start & clock comparators)
 *
 * (C) InSys by Dorokhin Andrey Feb 2004
 *
 * 14.11.2006 - add BRDctrl_CMPSC_GETDLGPAGES
 *
 ************************************************************
*/

#ifndef _CTRL_CMPSC_H
 #define _CTRL_CMPSC_H

#include "ctrladmpro.h"

enum {
	BRDctrl_CMPSC_SET				=	BRDctrl_CMN + 0,	// Set comparators (BRD_CMPSC)
	BRDctrl_CMPSC_GET				=	BRDctrl_CMN + 1,	// Get comparators (BRD_CMPSC)

	BRDctrl_CMPSC_GETDLGPAGES		=	BRDctrl_DAC + 127, // get property pages of comparators for dialog (PBRD_PropertyList)

	BRDctrl_CMPSC_ILLEGAL
};

#pragma pack(push, 1)    

typedef struct _BRD_CmpSC {
	U32		src;				// Comparator source 
	REAL64	thr[BRD_CMPNUM];	// Comparators Thresholds values 
} BRD_CmpSC, *PBRD_CmpSC;

#pragma pack(pop)    

#endif // _CTRL_CMPSC_H

//
// End of file
//