//********************************************************
//
// Example Application of BRD_xxx functions for GC5016 service.
//
// (C) InSys by Sklyarov A. Dec, 2006
//
//=********************************************************


#include	<conio.h>
#include	<stdio.h>
#include	<fcntl.h>
#include	<sys\stat.h>
#include	<share.h>
#include	<io.h>
#include	<tchar.h>
#include	<ctype.h>
#include	<windows.h>

#include	"brd.h"
#include	"ctrlstrm.h"
#include	"CtrlGc5016.h"
#include	"CtrlCmpSC.h"
#include	"ctrlsdram.h"
#define		PI2 6.2831853071795864
#define		kSpace	0x3920
#define		MaxNumParamDdc	2000

//---------------------------------------------------------------------------
typedef struct 
{
 U32   WorkMode;
 U32   SamplesPerChannel;
 U32   IsSystemMemory;
 U32   MasterSlave;
 U32   ReadModeSDRAM;
 U32   IsAlwaysLoadPld;
 TCHAR IniFileName[256];
 TCHAR PldFileName[256];
 TCHAR ServiceName[256];
}EXAM_PARAM;

EXAM_PARAM g_ExamParam=
{
	1,		// WorkMode: 0-one time DMA, 1-one time CPU
	1024,	// SamplesPerChannel
	0,		// IsSystemMemory
	0,		// MasterSlave;
	1,		// ReadModeSDRAM: 0-auto, 1 - free 
	0,		// IsAlwaysLoadPld: 1 - always
	{"\\exam_ddc214x400m.ini"}, //IniFileName
	{""},		// PldFileName
	{"GC50160"}	// ServiceName
};
//---------------------------------------------------------------------------
typedef struct 
{
    U32  ClockSource;
    U32  ClockValue;
	U32	 AdmMode;
    U32  MaskChannels;
  	U32	 SyncModeDdc;
  	U32	 StartSource;
	U32	 StartInverse;
	U32  StartTrigger; 
	U32	 StopSource;
	U32	 StopInverse;
	float ThresholdComp1;
    TCHAR PrgFileName[256];
} ADM_PARAM;				// ADMDDC5016 

ADM_PARAM   g_AdmParam =	// Read from ini-file
{
    0,			// ClockSource: 0-internal, 1-external
    160000000,	// ClockValue (Hz) for mode Adc-samples(g_ExamParam.AdmMode=0)
 	1,			// AdmMode: 0-samples from ADC, 1-samples from DDC
    1,			// ChannelsMask: 1,3 for mode Adc-samples(g_ExamParam.AdmMode=0)
  	1,			// SyncModeDdc: 1 -sync from start, 2-program
  	0,			// StartSource: source of start : 0-programm, 2-SDX(comparator 1)
	0,			// StartInverse: inverse signal start: 0-no, 1-yes    
	0,			// StartTrigger: start mode : 0- potential, 1-trigger
	0,			// StopSource: source of stop by trigger start mode
	0,			// StopInverse: inverse signal stop: 0-no, 1-yes
	0.1,		// ThresholdComp1 (v)
	{""},		// PldFileName
};
typedef struct{
	U32		ClockValue;				
	U32		ModeOfDdc;
	U32		MaskAdc;
	U32		MaskChannels;
	U32		Decimation[4];
	U32		Fc[4];
	U32		AdcChan[4];
	U32		ParamDdcChip[MaxNumParamDdc];
} DDC_PARAM, *PDDC_PARAM;

DDC_PARAM	g_DdcParam={ // For mode DDC-samples. Read from prg-file
	10000000,	//		ClockValue				
	0,			//		ModeOfDdc
	1,			//		MaskAdc
	1,		    //		MaskDdc;
	1,			//		MaskChannels
	8,			//		Decimation[0]
	8,			//		Decimation[1]
	8,			//		Decimation[2]
	8,			//		Decimation[3]
	10700000,	//		Fc[0]
	10700000,	//		Fc[1]
	10700000,	//		Fc[2]
	10700000,	//		Fc[3]
	0,			//		AdcChan[0]
	0,			//		AdcChan[1]
	0,			//		AdcChan[2]
	0,			//		AdcChan[3]
};

U32		Fc[4]={0,0,0,0};

PDDC_PARAM pDdcParam = &g_DdcParam;
U32 g_SdramWriteBufSize=1;
S32 g_nCaptSrv = 0;
U32 g_pCurBuf[10];
U32 *g_ppInpBuf[10];
BRD_Handle g_hCaptSrv[10];
S32	CaptureSrv(BRD_Handle handle,TCHAR* serviceName );
S32	SetParamSrv(void);
S32	WorkSrv(void);
//---------------------------------------------------------------------------
//=**************************** ReadIniPrepare ******************************
//=***************************************************************************
typedef struct {char section[25]; int format;void *ptr; char title[25]; } TReadIniEntry;
static TReadIniEntry    iniEntry[] =
{
	{"Option", 0, (void*)&g_ExamParam.WorkMode, "WorkMode" },
	{"Option", 0, (void*)&g_ExamParam.SamplesPerChannel, "SamplesPerChannel" },
	{"Option", 0, (void*)&g_ExamParam.IsSystemMemory, "IsSystemMemory" },
	{"Option", 0, (void*)&g_ExamParam.MasterSlave, "MasterSlave" },
	{"Option", 3, (void*)&g_ExamParam.PldFileName, "PldFileName" },
	{"Option", 0, (void*)&g_ExamParam.IsAlwaysLoadPld, "IsAlwaysLoadPld" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.ClockSource,"ClockSource" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.ClockValue,"ClockValue" },
	{"device0_gc50160", 0, (void*)&g_AdmParam.AdmMode, "AdmMode" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.MaskChannels,"MaskChannels" },
    {"device0_gc50160", 0, (void*)&Fc[0],"Fc0" },
    {"device0_gc50160", 0, (void*)&Fc[1],"Fc1" },
    {"device0_gc50160", 0, (void*)&Fc[2],"Fc2" },
    {"device0_gc50160", 0, (void*)&Fc[3],"Fc3" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.SyncModeDdc,"SyncModeDdc" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.StartSource,"StartSource" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.StartInverse,"StartInverse" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.StartTrigger,"StartTrigger" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.StopSource,"StopSource" },
    {"device0_gc50160", 0, (void*)&g_AdmParam.StopInverse,"StopInverse" },
    {"device0_gc50160", 1, (void*)&g_AdmParam.ThresholdComp1,"ThresholdComp1" },
	{"device0_gc50160", 3, (void*)&g_AdmParam.PrgFileName, "PrgFileName" },
};
//---------------------------------------------------------------------------

const U16 PLD_CFG_TAG	= 0x0500; // tag of PLD
TCHAR g_str[100];
int SetISVI=1;
U32	g_SizeInputBuf=1024;
U32 g_NumChans=0;
U32 *pInputBuf;
BRDctrl_StreamCBufAlloc buf_dscr[4];
BRDctrl_StreamCBufState streamState;

U32  g_NumItemsProgramDdc;
S32	 gMaxNumSamples=32768;	
U32  OutBuf[1048576*4];

bool ReadIniFile( char *pFileName );
void DisplayError(S32 status, TCHAR* cmd_str);
S32	 CaptureSrv(BRD_Handle handle,TCHAR* serviceName );
S32	 SetParamSrv(void);
S32  WorkSrv(void);
S32  FifoInputDMA(void);
S32	 ReadPrgFile(TCHAR *filename, U32 *dst, PDDC_PARAM pParam,int maxsize);
void WriteFlagSinc(int flg, int isNewParam);
S32  ReadFlagSinc(void);
S32  WriteFileISVI_Adc(U32 *src);
S32  WriteFileISVI_Ddc(U32 *src);
void FormBufferForISVI(void);
U32	 ReadSampleAdc(U32* src, U32 HiLow);
S32  GetBufSamples(void);
S32  SdramInputDMA(void);
bool SetParamSDRAM(S32 iSrv);
S32	 SdramFifoInputDMA(void);
//=*************************************** main ************************************************
//=*********************************************************************************************
void main( int argc, char *argv[] )
{
	S32		status;
	if(!ReadIniFile(g_ExamParam.IniFileName ))
	{
		printf("Can't open file: %s !\n",g_ExamParam.IniFileName);
		printf("Press any key for leaving program...\n");
		_getch();
		_exit(0);
	}
	if(g_AdmParam.AdmMode==1) // Samples from DDC
	{	
		g_NumItemsProgramDdc=ReadPrgFile(g_AdmParam.PrgFileName, g_DdcParam.ParamDdcChip, pDdcParam,MaxNumParamDdc);
		if(g_NumItemsProgramDdc==-1)
		{
			printf("Can't open file: %s !\n",g_AdmParam.PrgFileName);
			printf("Press any key for leaving program...\n");
			_getch();
			_exit(0);
		}
	}
	g_SdramWriteBufSize *=1024;
	BRD_displayMode(BRDdm_VISIBLE | BRDdm_CONSOLE); //     :     
	
	S32	DevNum;
	status = BRD_init("brd.ini", &DevNum); //  

	//   LID (   )
	BRD_LidList lidList;
	lidList.item = 10;
	lidList.pLID = new U32[10];
	status = BRD_lidList(lidList.pLID, lidList.item, &lidList.itemReal);

	BRD_Info	info;
	info.size = sizeof(info);
	BRD_Handle handle[10];

	for(ULONG iDev = 0; iDev < lidList.itemReal; iDev++)
	{
		BRD_getInfo(lidList.pLID[iDev], &info); //    
		printf("Board %d:  %s pid = %d\n",iDev,info.name,info.pid);
		printf("   DevID = 0x%x, RevID = 0x%x, Bus = %d, Dev= %d, Slot= %d.\n", 
			    info.boardType >> 16, info.boardType & 0xff, info.bus, info.dev, info.slot);
		handle[iDev] = BRD_open(lidList.pLID[iDev], BRDopen_SHARED, NULL); //  
		if(handle[iDev] <=0)printf("   Open Error!\n");
		if(handle[iDev] > 0)
		{
			BRD_PuList PuList[5];
			U32 ItemReal;
			status = BRD_puList(handle[iDev], PuList, 5, &ItemReal); //    
			if(ItemReal > 5)
			{
				ItemReal=5; 
				printf("   Number of programable unit >5 !\n");
			}
			for(U32 j = 0; j < ItemReal; j++)
			{
				printf("   Prog unit %d: %s, Id = %d, Code = %x, Attr = %x.\n",
									j, PuList[j].puDescription, PuList[j].puId, PuList[j].puCode, PuList[j].puAttr);
				
				if(PuList[j].puCode == PLD_CFG_TAG)
				{ //   
						U32	PldState;
						status = BRD_puState(handle[iDev], PuList[j].puId, &PldState);
						printf("   PLD State = %d\n", PldState);
						if(PldState==0 || g_ExamParam.IsAlwaysLoadPld==1)
						{ //  
					 		printf("   Loading PLD -> %s ...",g_ExamParam.PldFileName);
							status = BRD_puLoad(handle[iDev], PuList[j].puId, g_ExamParam.PldFileName, &PldState);
							if(BRD_errcmp(status, BRDerr_OK))
							{	
								printf(" OK!\n");
								PldState=1;
							}
							else 
							{	
								printf("  Error! \n");
								PldState=0;
							}
					    }
						if(PldState)CaptureSrv(handle[iDev],g_ExamParam.ServiceName);		
		         }
             }
         }
	}
	if(g_nCaptSrv>0)
	{
		SetParamSrv();
		WorkSrv();
	}else
	{
		printf("\n   No Service!\n");
	}
	for(int i = 0; i < g_nCaptSrv; i++)
		status = BRD_release(g_hCaptSrv[i], 0);
	for(ULONG iDev = 0; iDev < lidList.itemReal; iDev++)
		status = BRD_close(handle[iDev]); //   
	printf("\n BRD_close: OK\n");
	status = BRD_cleanup();
	printf(" BRD_cleanup: OK\n");
	printf("Press any key for leaving program...\n");
	_getch();
}
//-******************************** End main **************************************
//=*****************************   *********************************
//=*********************************************************************************
S32	CaptureSrv(BRD_Handle handle,TCHAR* serviceName )
{
	S32		status;
	U32 mode = BRDcapt_EXCLUSIVE;
	U32	ItemReal;
	BRD_ServList srvList[10];
	status = BRD_serviceList(handle, 0, srvList, 10, &ItemReal);
	for(U32 j = 0; j < ItemReal; j++)
	{
		printf("   Srv %d:  %s, Attr = %X.\n",j, srvList[j].name, srvList[j].attr);
	}
    for(U32 iSrv = 0;iSrv < ItemReal; iSrv++)
    {			
		if(!strcmp(srvList[iSrv].name,g_ExamParam.ServiceName))
		{
		   printf("   Capture %s mode: EXCLUSIVE...",g_ExamParam.ServiceName); 
		   BRD_Handle hSrv = BRD_capture(handle, 0, &mode,srvList[iSrv].name, 10000);
			if(hSrv > 0)
			{
				g_hCaptSrv[g_nCaptSrv++]=hSrv;
				printf("OK!\n");

			}else
			{
				printf("Error!\n");
			}
		}
    }	
	return status;
}
//=**************************************************************************
//					    
//=**************************************************************************
S32	SetParamSrv(void)
{
	S32	status;
	U32 master0=BRDims_SINGLE;
	U32 master1=BRDims_SINGLE;
	U32 master=BRDims_SINGLE;
	BRD_ClkMode clk_mode;
	BRD_GC5016AdcSetGain set_gain;
	U32 ddcmode = 0;
	U32 enbadc;
	U32  mchans;
	BRD_StartMode  startMode;
	BRD_CmpSC cmp_sc;
	BRD_GC5016SetSync ddcSetSync;
	BRD_GC5016Program ddcProgram;
	BRD_GC5016SetFc  setFc;
	BRD_GC5016Cfg  cfgAdm;

	for(int iSrv=g_nCaptSrv-1;iSrv>=0;iSrv--)
	{
	
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_GETCFG, &cfgAdm);
		if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_GC5016_GETCFG");
		switch(cfgAdm.SubType){
			case 0x0a0b: printf("Submodule = ADMDDC5016\n"); break;
			case 0x0a0c: printf("Submodule = ADMDDC416x100M\n"); break;
			case 0x0a0d: printf("Submodule = ADMDDC214x400M\n"); break;
			default:	printf("Submodule = Unknown\n");	break;
		}
		printf("PldAdm = 0x%x\n",cfgAdm.AdmConst);
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETMASTER, &master);
		if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_GC5016_SETMASTER");

		//---------------------     ---------------------
		clk_mode.src = g_AdmParam.ClockSource;
		clk_mode.value = g_AdmParam.ClockValue;
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETCLKMODE, &clk_mode);
		if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_GC5016_SETCLKMODE");

		g_AdmParam.ClockSource = clk_mode.src;
		g_AdmParam.ClockValue = (U32)clk_mode.value;

		if(g_AdmParam.ClockSource==0)printf("ClockSource = INTERNAL\n");
		else  printf("ClockSource = EXTERNAL\n");
		printf("ClockValue = %d Hz\n",g_AdmParam.ClockValue);

		//-----------------------    (  DDC) -------------------
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETADMMODE, &g_AdmParam.AdmMode);
		if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_SETADMMODE");	

		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETDDCMODE, &ddcmode);
		if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_SETDDCMODE");	

		//-------------------------   -------------------------------------------
		if(g_AdmParam.AdmMode==0)enbadc=g_AdmParam.MaskChannels |1; 	//   
		if(g_AdmParam.AdmMode==1)enbadc=g_DdcParam.MaskAdc;				//   DDC
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_ADCENABLE, &enbadc);
		if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_GC5016_ADCENABLE");

		//----------------------     ---------------------------------
		if(g_AdmParam.AdmMode==0)mchans=g_AdmParam.MaskChannels;	//   
		if(g_AdmParam.AdmMode==1)mchans=g_DdcParam.MaskChannels;	//   DDC
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETCHANMASK, &mchans);
		if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_GC5016_SETCHANMASK");

		//-----------------------    ----------------------------------
		if((iSrv>0)&& (g_ExamParam.MasterSlave==1))startMode.startSrc=0;
		else startMode.startSrc= g_AdmParam.StartSource;
		startMode.startInv= g_AdmParam.StartInverse;
		startMode.trigOn= g_AdmParam.StartTrigger;
		startMode.trigStopSrc= g_AdmParam.StopSource;
		startMode.stopInv= g_AdmParam.StopInverse;
		startMode.reStartMode=0;
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETSTARTMODE, &startMode);
		if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_SETSTARTMODE");
		cmp_sc.src = BRDcmps_CHAN0CLK;
		cmp_sc.thr[0] = g_AdmParam.ThresholdComp1;
		cmp_sc.thr[1] = g_AdmParam.ThresholdComp1;
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_CMPSC_SET, &cmp_sc);
		if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_CMPSC_SET");

		status=BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_STOPDDC, NULL); //  DDC
	//--------------------------   DDC --------------------------------------
		if(g_AdmParam.AdmMode==1)		//   DDC
		{
			printf("PrgFileName = %s\n",g_AdmParam.PrgFileName);
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETDDCMODE, &g_DdcParam.ModeOfDdc);
			if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_GC5016_SETDDCMODE");

			ddcProgram.nItems=g_NumItemsProgramDdc; 
			ddcProgram.pData=g_DdcParam.ParamDdcChip;
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_PROGRAMDDC, &ddcProgram);
			if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_PROGRAMDDC");
	
			if(Fc[0]!=0)
			{
				g_DdcParam.Fc[0]=Fc[0];
				setFc.maskChans=0x1;
				setFc.Fc=g_DdcParam.Fc[0];
				status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETDDCFC, &setFc);
				if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_SETDDCFC");
			}
			if(Fc[1]!=0)
			{
				g_DdcParam.Fc[1]=Fc[1];
				setFc.maskChans=0x2;
				setFc.Fc=g_DdcParam.Fc[1]; 
				status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETDDCFC, &setFc);
				if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_SETDDCFC");
			}
			if(Fc[2]!=0)
			{
				g_DdcParam.Fc[2]=Fc[2];
				setFc.maskChans=0x4;
				setFc.Fc=g_DdcParam.Fc[2];
				status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETDDCFC, &setFc);
				if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_SETDDCFC");
			}
			if(Fc[3]!=0)
			{
				g_DdcParam.Fc[3]=Fc[3];
				setFc.maskChans=0x8;
				setFc.Fc=g_DdcParam.Fc[3]; 
				status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETDDCFC, &setFc);
				if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_SETDDCFC");
			}
			status=BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_STARTDDC, NULL); //  DDC
			if(!BRD_errcmp(status, BRDerr_OK))DisplayError(status, "BRDctrl_GC5016_STARTDDC");

			ddcSetSync.syncMode=g_AdmParam.SyncModeDdc;
			ddcSetSync.progSync=1;
			ddcSetSync.slave=0;
			ddcSetSync.resDiv=0;
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETDDCSYNC, &ddcSetSync);
			if(!BRD_errcmp(status, BRDerr_OK)) DisplayError(status, "BRDctrl_GC5016_SETDDCSYNC");


		}
	}

	return 1;
}
//=*************************************************************************************
//					  
//=*************************************************************************************
//--------------------------------------------------------------------------------------
S32	WorkSrv(void)
{
	S32	iSrv=0;
	S32	status,Status;
 	U32 isISVI;
	U32 tetrad;
	U32 target;
	BRD_GC5016SetFc  setFc;
	//----------------     ----------------------------------
	if(g_AdmParam.AdmMode==0)//	  
	{
		for(int i=0;i<4;i++)
			if(g_AdmParam.MaskChannels&(1<<i))g_NumChans++;
		g_SizeInputBuf=g_NumChans*g_ExamParam.SamplesPerChannel*2;
		printf("\nSamples from ADC\n");
	}
	if(g_AdmParam.AdmMode==1)//	   DDC
	{
		for(int i=0;i<4;i++)
			if(g_DdcParam.MaskChannels&(1<<i))g_NumChans++;
		g_SizeInputBuf=g_NumChans*g_ExamParam.SamplesPerChannel*4;
		printf("\nSamples from DDC\n");
	}
	int	nmin = g_SizeInputBuf/4096;
	if((g_SizeInputBuf%4096!=0)  || (nmin==0))
	{
		g_SizeInputBuf = 4096*(nmin+1);
		g_ExamParam.SamplesPerChannel=g_SizeInputBuf/(g_NumChans*2);
		if(g_AdmParam.AdmMode==1)g_ExamParam.SamplesPerChannel /=2;
		printf("\nSamplesPerChannel from ini-file too small !\n");

	}
//----------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------
	if(g_ExamParam.WorkMode==0)		//       FIFO ADM   
									//   
	{								//---------------------------------------------------------
 	
		target = 0;		//  data to FIFO
		printf("SamplesPerChannel= %d\n",g_ExamParam.SamplesPerChannel);
		printf("\nWorkMode = 0 - One time acquisition data with stream from FIFO ADM\n");
		for(int iSrv=0;iSrv<g_nCaptSrv;iSrv++)
		{
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETTARGET, &target);
			buf_dscr[iSrv].dir = BRDstrm_DIR_IN;
			buf_dscr[iSrv].isCont = g_ExamParam.IsSystemMemory; 
			buf_dscr[iSrv].blkNum = 1;
			buf_dscr[iSrv].blkSize = g_SizeInputBuf;
			buf_dscr[iSrv].ppBlk = new PVOID[buf_dscr[iSrv].blkNum];
			status = BRD_ctrl(g_hCaptSrv[iSrv],0, BRDctrl_STREAM_CBUF_ALLOC, &buf_dscr[iSrv]);

			BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_GETSRCSTREAM, &tetrad);
			BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_SETSRC, &tetrad);
		}
		S32 nf=0;
		printf("Press any key for stop...\n");
	    while(!_kbhit())
		{
			if(FifoInputDMA())
			{
				nf = -1;
				break; // ,      (   TIMEOUT)
			}
			FormBufferForISVI();
			if(g_AdmParam.AdmMode==0)
				isISVI = WriteFileISVI_Adc(OutBuf);	//   
			else
				isISVI = WriteFileISVI_Ddc(OutBuf);	//   DDC
			nf++;
			if(isISVI)
				printf("\rFile=%d           ",nf);
			else
				printf("\rFile=%d  No ISVI!",nf);

		}
 		if(nf > 0)
			_getch(); //       Esc
		for(int iSrv=0;iSrv<g_nCaptSrv;iSrv++)
		{
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_CBUF_FREE, &buf_dscr[iSrv]);
			delete[] buf_dscr[iSrv].ppBlk;
		}
	}
//--------------------------------------------------------------------------------------------------------
	if(g_ExamParam.WorkMode==1)		// ()      FIFO ADM   
	{								//--------------------------------------------------------------------
 		target = 0;		//  data to FIFO
		ULONG flag=BRDstrm_DRQ_ALMOST;
		//ULONG flag = BRDstrm_DRQ_HALF; 
		printf("\nWorkMode = 1 - Continuous acquisition data with stream from FIFO ADM\n");
		for(int iSrv=0;iSrv<g_nCaptSrv;iSrv++)
		{
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETTARGET, &target);
			buf_dscr[iSrv].dir = BRDstrm_DIR_IN;
			buf_dscr[iSrv].isCont = g_ExamParam.IsSystemMemory; 
			buf_dscr[iSrv].blkNum = 16;
			buf_dscr[iSrv].blkSize = g_SizeInputBuf;
			buf_dscr[iSrv].ppBlk = new PVOID[buf_dscr[iSrv].blkNum];
			status = BRD_ctrl(g_hCaptSrv[iSrv],0, BRDctrl_STREAM_CBUF_ALLOC, &buf_dscr[iSrv]);

			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_GETSRCSTREAM, &tetrad);
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_SETSRC, &tetrad);

			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_SETDRQ, &flag);
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_STOP, NULL);		//  GC5016
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_FIFORESET, NULL); //  FIFO 
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_FIFOSTATUS, &Status);
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_RESETFIFO, NULL);

			BRDctrl_StreamCBufStart start_pars;
			start_pars.isCycle = 1; //  cycle 

			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_CBUF_START, &start_pars); //  
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_START, NULL);			    //  GC5016 

		}
		S32 nf=0;
	    while(!_kbhit())
		{
			if(GetBufSamples())break; // ,      (   TIMEOUT)

	//		FormBufferForISVI();
//--------------------------------------------------------------------------------------------------------
			U32 *pInp=g_ppInpBuf[0];
			for(U32 i=0;i<g_SizeInputBuf/4; i++)OutBuf[i]=pInp[i];
//--------------------------------------------------------------------------------------------------------

			if(g_AdmParam.AdmMode==0)
				isISVI = WriteFileISVI_Adc(OutBuf);	//   
			else
				isISVI = WriteFileISVI_Ddc(OutBuf);	//   DDC
			nf++;
			if(isISVI)
				printf("\rFile=%d           ",nf);
			else
				printf("\rFile=%d  No ISVI!",nf);

			//--------------------------------------------------------------------------------------------
		}
		_getch(); 
		for(int iSrv=0;iSrv<g_nCaptSrv;iSrv++)
		{
		    status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_STOP, NULL); //  GC5016 
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_CBUF_FREE, &buf_dscr[iSrv]);
			delete[] buf_dscr[iSrv].ppBlk;
		}
	}
//--------------------------------------------------------------------------------------------------------
	if(g_ExamParam.WorkMode==2)		//    SDRAM,      SDRAM    
									//   
	{								//--------------------------------------------------------------------
		for(int iSrv=0;iSrv<g_nCaptSrv;iSrv++)
		{
			SetParamSDRAM(iSrv);
		}
		target = 2;		//  data to SDRAM
		printf("SamplesPerChannel= %d\n",g_ExamParam.SamplesPerChannel);
		printf("\nWorkMode = 2 - One time acquisition data with stream from FIFO SDRAM\n");
		for(int iSrv=0;iSrv<g_nCaptSrv;iSrv++)
		{
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETTARGET, &target);
			buf_dscr[iSrv].dir = BRDstrm_DIR_IN;
			buf_dscr[iSrv].isCont = g_ExamParam.IsSystemMemory; 
			buf_dscr[iSrv].blkNum = 1;
			buf_dscr[iSrv].blkSize = g_SizeInputBuf;
			buf_dscr[iSrv].ppBlk = new PVOID[buf_dscr[iSrv].blkNum];
			status = BRD_ctrl(g_hCaptSrv[iSrv],0, BRDctrl_STREAM_CBUF_ALLOC, &buf_dscr[iSrv]);

		    BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_GETSRCSTREAM, &tetrad);
			BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_SETSRC, &tetrad);
		}
		S32 nf=0;
		printf("Press any key for stop...\n");
	    while(!_kbhit())
		{
			if(SdramInputDMA())
			{
				nf = -1;
				break; // ,      (   TIMEOUT)
			}
			FormBufferForISVI();
			if(g_AdmParam.AdmMode==0)
				isISVI = WriteFileISVI_Adc(OutBuf);	//   
			else
				isISVI = WriteFileISVI_Ddc(OutBuf);	//   DDC
			nf++;
			if(isISVI)
				printf("\rFile=%d           ",nf);
			else
				printf("\rFile=%d  No ISVI!",nf);

		}
 		if(nf > 0)
			_getch(); //       Esc
		for(int iSrv=0;iSrv<g_nCaptSrv;iSrv++)
		{
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_CBUF_FREE, &buf_dscr[iSrv]);
			delete[] buf_dscr[iSrv].ppBlk;
		}
	}

//---------------------------------------------------------------------------------------------------
	if(g_ExamParam.WorkMode==3)		//    SDRAM    (SDRAM   FIFO)
									//   
	{								//---------------------------------------------------------------
		ULONG fifo_mode=1; //    FIFO
		for(int iSrv=0;iSrv<g_nCaptSrv;iSrv++)
		{
			SetParamSDRAM(iSrv);
		}
		target = 2;		//  data to SDRAM
		printf("SamplesPerChannel= %d\n",g_ExamParam.SamplesPerChannel);
		printf("\nWorkMode = 3 - One time acquisition data with stream(SDRAM in mode FIFO)\n");
		for(int iSrv=0;iSrv<g_nCaptSrv;iSrv++)
		{
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETTARGET, &target);
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_SETFIFOMODE, &fifo_mode);

			buf_dscr[iSrv].dir = BRDstrm_DIR_IN;
			buf_dscr[iSrv].isCont = g_ExamParam.IsSystemMemory; 
			buf_dscr[iSrv].blkNum = 1;
			buf_dscr[iSrv].blkSize = g_SizeInputBuf;
			buf_dscr[iSrv].ppBlk = new PVOID[buf_dscr[iSrv].blkNum];
			status = BRD_ctrl(g_hCaptSrv[iSrv],0, BRDctrl_STREAM_CBUF_ALLOC, &buf_dscr[iSrv]);

		    BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_GETSRCSTREAM, &tetrad);
			BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_SETSRC, &tetrad);
		}
		S32 nf=0;
		printf("Press any key for stop...\n");
	    while(!_kbhit())
		{
			if(SdramFifoInputDMA())
			{
				nf = -1;
				break; // ,      (   TIMEOUT)
			}
			FormBufferForISVI();
			if(g_AdmParam.AdmMode==0)
				isISVI = WriteFileISVI_Adc(OutBuf);	//   
			else
				isISVI = WriteFileISVI_Ddc(OutBuf);	//   DDC
			nf++;
			if(isISVI)
				printf("\rFile=%d           ",nf);
			else
				printf("\rFile=%d  No ISVI!",nf);

		}
 		if(nf > 0)
			_getch(); //       Esc
		for(int iSrv=0;iSrv<g_nCaptSrv;iSrv++)
		{
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_CBUF_FREE, &buf_dscr[iSrv]);
			delete[] buf_dscr[iSrv].ppBlk;
		}
	}
//--------------------------------------------------------------------------------------------------------------
	if(g_ExamParam.WorkMode==4)		// ()   SDRAM   (SDRAM   FIFO)
	{								//--------------------------------------------------------------------------
 		target = 2;		//  data to SDRAM
		U32 Enable = 1;
		ULONG flag=BRDstrm_DRQ_ALMOST;
		//ULONG flag = BRDstrm_DRQ_HALF; 
		printf("\nWorkMode = 4 - Continuous acquisition data with stream(SDRAM in mode FIFO)\n");
		for(int iSrv=0;iSrv<g_nCaptSrv;iSrv++)
		{
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_SETTARGET, &target);
			buf_dscr[iSrv].dir = BRDstrm_DIR_IN;
			buf_dscr[iSrv].isCont = g_ExamParam.IsSystemMemory; 
			buf_dscr[iSrv].blkNum = 16;
			buf_dscr[iSrv].blkSize = g_SizeInputBuf;
			buf_dscr[iSrv].ppBlk = new PVOID[buf_dscr[iSrv].blkNum];
			status = BRD_ctrl(g_hCaptSrv[iSrv],0, BRDctrl_STREAM_CBUF_ALLOC, &buf_dscr[iSrv]);

			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_GETSRCSTREAM, &tetrad);
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_SETSRC, &tetrad);

			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_SETDRQ, &flag);
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_STOP, NULL);		//  GC5016
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_FIFORESET, NULL); //  FIFO 
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_RESETFIFO, NULL);
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_FIFORESET, NULL);  // reset  FIFO SDRAM
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_RESETFIFO, NULL);
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_ENABLE, &Enable);  // enable write to SDRAM

			BRDctrl_StreamCBufStart start_pars;
			start_pars.isCycle = 1; //  cycle 

			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_CBUF_START, &start_pars); //  
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_START, NULL);			    //  GC5016 

		}
		S32 nf=0;
	    while(!_kbhit())
		{
			if(GetBufSamples())break; // ,      (   TIMEOUT)

		FormBufferForISVI();
//--------------------------------------------------------------------------------------------------------
		//	U32 *pInp=g_ppInpBuf[0];
		//	for(U32 i=0;i<g_SizeInputBuf/4; i++)OutBuf[i]=pInp[i];
//--------------------------------------------------------------------------------------------------------

			if(g_AdmParam.AdmMode==0)
				isISVI = WriteFileISVI_Adc(OutBuf);	//   
			else
				isISVI = WriteFileISVI_Ddc(OutBuf);	//   DDC
			nf++;
			if(isISVI)
				printf("\rFile=%d           ",nf);
			else
				printf("\rFile=%d  No ISVI!",nf);

			//--------------------------------------------------------------------------------------------
		}
		_getch(); 
		for(int iSrv=0;iSrv<g_nCaptSrv;iSrv++)
		{
		    status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_STOP, NULL); //  GC5016 
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_CBUF_FREE, &buf_dscr[iSrv]);
			delete[] buf_dscr[iSrv].ppBlk;
		}
	}
//--------------------------------------------------------------------------------------------------------
	//------------------------------------------------------------------------------------------

	return 1;
}

//=*********************************************************************************
//-*************       STREAM *************
//=*********************************************************************************
S32 GetBufSamples(void)
{
	S32		status=0,ret=0;
    ULONG msTimeout = 20000 ;
	for(S32 iSrv=0;iSrv<g_nCaptSrv;iSrv++)
	{
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_CBUF_WAITBLOCK, &msTimeout);
   		if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
   		{
 			printf("\nTIME-OUT! \n");
  	        ret=1;
		}
	}
	for(S32 iSrv=0;iSrv<g_nCaptSrv;iSrv++)
	{
      g_pCurBuf[iSrv]= buf_dscr[0].pStub->totalCounter;
      g_ppInpBuf[iSrv]=(U32*)buf_dscr[iSrv].ppBlk[buf_dscr[iSrv].pStub->lastBlock];
	}
      return ret;
}

//=*********************************************************************************
//-********************    ISVI *******************************
//=*********************************************************************************
void FormBufferForISVI(void)
{
	U32 *pInp;
	U32	indr=0,ind=0;
	U32	sample;
	U32 iHiLow=0;
	U32 nwr=0;
	if(g_AdmParam.AdmMode==0)	//----   
	{
		//-------------------- 
		if(g_NumChans==1)
		{	
			pInp=(U32*)buf_dscr[0].ppBlk[0];

			for(U32 i=0;i<g_ExamParam.SamplesPerChannel; i++)
			{
				for(int j=0;j<g_nCaptSrv; j++)
				{
					pInp=(U32*)buf_dscr[j].ppBlk[0];
					sample=ReadSampleAdc(&pInp[indr],iHiLow);
					if((nwr&1)==0)
					{
						OutBuf[ind]=sample;//pInp[k+i*g_NumChans];
					}
					else
					{
						OutBuf[ind] |=sample<<16;
						ind++;
					}
					nwr++;
				}
				iHiLow++;
				if(iHiLow==2)indr++;
				iHiLow &=1;
			}
		}
		//------------------
		if(g_NumChans==2 || g_NumChans==4)
		{
			for(U32 i=0;i<g_ExamParam.SamplesPerChannel*(g_NumChans/2); i++)
			{
				for(int j=0;j<g_nCaptSrv; j++)
				{
					pInp=(U32*)buf_dscr[j].ppBlk[0];
 					OutBuf[ind]=pInp[i];
					ind++;
				}
			}
		}
	}
//--------------------------------------------------------------------------------
	if(g_AdmParam.AdmMode==1)	// ------   DDC
	{
		for( U32 i=0;i<g_ExamParam.SamplesPerChannel; i++)
		{
			for(int j=0;j<g_nCaptSrv; j++)
			{
				pInp=(U32*)buf_dscr[j].ppBlk[0];

				for(U32 k=0;k<g_NumChans; k++)
				{
					OutBuf[ind]=pInp[k+i*g_NumChans];
					ind++;
				}
			}
		}
	}
//---------------------------------------------------------------------------------
}
//=*********************************************************************************
U32	ReadSampleAdc(U32* src, U32 HiLow)
{
	if(HiLow==0)return (*src&0xffff);
	if(HiLow==1)return ((*src>>16)&0xffff);
	return (*src&0xffff);

}
//=*********************************************************************************
void DisplayError(S32 status, TCHAR* cmd_str)
{
	S32	real_status = BRD_errext(status);
	TCHAR msg[255];
	switch(real_status)
	{
	case BRDerr_OK:
		sprintf_s(msg, "%s: BRDerr_OK\n", cmd_str);
		break;
	case BRDerr_BAD_MODE:
		sprintf_s(msg, "%s: BRDerr_BAD_MODE\n", cmd_str);
		break;
	case BRDerr_INSUFFICIENT_SERVICES:
		sprintf_s(msg, "%s: BRDerr_INSUFFICIENT_SERVICES\n", cmd_str);
		break;
	default:
		sprintf_s(msg, "%s: Unknown error\n", cmd_str);
		break;
	}
	printf(msg);
}
//=*********************************************************************************

//      ini-:
//    FileName -  ini- ( ,  )
//    SectionName -  
//    ParamName -   ()
//    defValue -   - (    )
//    strValue -  
//    strSize -   
static void GetInifileString(LPCTSTR FileName, LPCTSTR SectionName, LPCTSTR ParamName, LPSTR defValue, LPSTR strValue, int strSize)
{
	GetPrivateProfileString(SectionName, ParamName, defValue, strValue, strSize, FileName);
	TCHAR* pChar = _tcschr(strValue, ';');
	if(pChar) *pChar = 0; //    
	int str_size = lstrlen(strValue);
	for(int i = str_size - 1; i > 1; i--)
		if(strValue[i] != ' ' && strValue[i] != '\t')
		{
			strValue[i+1] = 0;
			break;
		}
}
//=*********************************************************************
//=**************************   ****************
//=*********************************************************************
bool    ReadIniFile( TCHAR *pFileName )
{
	TCHAR Buffer[128];
	TCHAR *endptr;
	TCHAR iniFilePath[MAX_PATH];
	FILE    *stream;

	GetCurrentDirectory(sizeof(iniFilePath)/sizeof(TCHAR), iniFilePath);

	_tcscat_s(iniFilePath, pFileName);
	stream = fopen(iniFilePath, "rt" );
    if( stream == NULL)return false;
	else     fclose(stream);

    for(int i=0; i<sizeof(iniEntry)/sizeof(iniEntry[0]); i++ )
	{
		GetPrivateProfileString(iniEntry[i].section, iniEntry[i].title, "0", Buffer, sizeof(Buffer), iniFilePath);
		switch(iniEntry[i].format){
			case 0:	
				{
					int     base = 10;
					char    *s = Buffer;
					while (isspace(*s)) s++;
                    if( (s[0]=='0') && ((s[1]=='x') || (s[1]=='X')) )
                    base = 16;
                    *(int*)iniEntry[i].ptr = strtoul( Buffer, &endptr, base );
				}
				break;
			case 1:	*(float*)iniEntry[i].ptr=(float)atof(Buffer);
				break;
			case 2:	*(double*)iniEntry[i].ptr=atof(Buffer);
				break;
			case 3:	 
				GetInifileString(iniFilePath, iniEntry[i].section, iniEntry[i].title, "0", Buffer, sizeof(Buffer));
				lstrcpy((TCHAR*)iniEntry[i].ptr,Buffer);
				break;

		}
	}
	return true;
}
//=*******************************************************************************
//*****************   FIFO  ADM       ******************
//********************************************************************************
S32 FifoInputDMA(void)
{
	S32		status,Status;

	//ULONG flag=BRDstrm_DRQ_ALMOST;
	ULONG flag = BRDstrm_DRQ_HALF; 
	BRDctrl_StreamCBufStart start_pars;
	start_pars.isCycle = 0; // no cycle 

	for(int iSrv=g_nCaptSrv-1;iSrv>=0;iSrv--)
	{
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_SETDRQ, &flag);
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_STOP, NULL);		//  GC5016
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_FIFORESET, NULL); //  FIFO 
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_FIFOSTATUS, &Status);
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_RESETFIFO, NULL);
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_CBUF_START, &start_pars); //  
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_START, NULL);			    //  GC5016 
	}
	int fl_break = 0;
    ULONG msTimeout = 20000; // wait end input (20 s)
    status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_STREAM_CBUF_WAITBUF, &msTimeout);

    if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
	{	
		printf("\nTIME-OUT! \n");
		fl_break = 1;
	}
	for(int iSrv=0; iSrv<g_nCaptSrv; iSrv++)
	{
	    status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_STOP, NULL); //  GC5016 
	}

		return fl_break;
}
//******************************************************************************************
//*****************   SDRAM,   SDRAM      *****************
//******************************************************************************************
S32 SdramInputDMA(void)
{
	S32		status,Status;
	U32 Enable = 1;
	ULONG addr = 0;
	ULONG mem_size;
	ULONG flag = BRDstrm_DRQ_HALF; 
	//--------------------------------------------------------------------------------
	Enable = 1;
	for(int iSrv=g_nCaptSrv-1;iSrv>=0;iSrv--)
	{
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_FIFORESET, NULL); // reset FIFO GC5015

		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_FIFORESET, NULL);  // reset  FIFO SDRAM
		status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_SDRAM_ISACQCOMPLETE, &Status);
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_ENABLE, &Enable);  // enable write to SDRAM
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_START, NULL);	  // start GC5016
	}
		// wait end input
	do {
		status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_SDRAM_ISACQCOMPLETE, &Status);
	} while(!Status);
	for(int iSrv=g_nCaptSrv-1;iSrv>=0;iSrv--)
	{
		Enable = 0;
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_SETDRQ, &flag);
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_STOP, NULL); // stop  GC5016
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_ENABLE, &Enable); // disable write SDRAM

		Enable=1;
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_READENABLE, &Enable); // enable read SDRAM
	}
	//--------------------------------------------------------------------------------
	for(int iSrv=g_nCaptSrv-1;iSrv>=0;iSrv--)
	{

		BRDctrl_StreamCBufStart start_pars;
		start_pars.isCycle = 0; // no cycle 

		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_RESETFIFO, NULL);
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_CBUF_START, &start_pars); //  

	}
	int fl_break = 0;
    ULONG msTimeout = 20000; // wait end input (20 s)
    status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_STREAM_CBUF_WAITBUF, &msTimeout);
    if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
	{	
		printf("\nTIME-OUT! \n");
		fl_break = 1;
	}

	Enable=0;
	for(int iSrv=g_nCaptSrv-1;iSrv>=0;iSrv--)
	{
		status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_SDRAM_READENABLE, &Enable); // enable read SDRAM
	}
 
		return fl_break;
}
//******************************************************************************************
//*****************      SDRAM (SDRAM   FIFO)**********************
//******************************************************************************************
S32 SdramFifoInputDMA(void)
{
	S32		status,Status;
	U32 Enable = 1;
	ULONG addr = 0;
	ULONG mem_size;
	ULONG flag = BRDstrm_DRQ_HALF; 
	//--------------------------------------------------------------------------------
	BRDctrl_StreamCBufStart start_pars;
	start_pars.isCycle = 0; // no cycle 

	Enable = 1;
	for(int iSrv=g_nCaptSrv-1;iSrv>=0;iSrv--)
	{
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_SETDRQ, &flag);
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_FIFORESET, NULL); // reset FIFO GC5015

		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_FIFORESET, NULL);  // reset  FIFO SDRAM
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_RESETFIFO, NULL);
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_ENABLE, &Enable);  // enable write to SDRAM
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_STREAM_CBUF_START, &start_pars); //  
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_START, NULL);	  // start GC5016
	}
		// wait end input
	int fl_break = 0;
    ULONG msTimeout = 20000; // wait end input (20 s)
    status = BRD_ctrl(g_hCaptSrv[0], 0, BRDctrl_STREAM_CBUF_WAITBUF, &msTimeout);
    if(BRD_errcmp(status, BRDerr_WAIT_TIMEOUT))
	{	
		printf("\nTIME-OUT! \n");
		fl_break = 1;
	}
	for(int iSrv=g_nCaptSrv-1;iSrv>=0;iSrv--)
	{
		Enable = 0;
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_GC5016_STOP, NULL); // stop  GC5016
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_ENABLE, &Enable); // disable write SDRAM

	}

 
		return fl_break;
}
//******************************************************************************************
bool SetParamSDRAM(S32 iSrv)
{
	
		S32	status;
		BRD_SdramCfg SdramConfig;
		ULONG PhysMemSize;
		status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_GETCFG, &SdramConfig);
		if(status < 0)
		{
			PhysMemSize = 0; // SDRAM is absent
			return false;
		}
		else
		{					// SDRAM is available
			PhysMemSize =	(1 << SdramConfig.RowAddrBits) *
							(1 << SdramConfig.ColAddrBits) * 
							SdramConfig.ModuleBanks * 
							SdramConfig.ChipBanks *
							SdramConfig.ModuleCnt * 2; // size (U32)

			ULONG mode = 1;    // 0 - AUTO, 1 - RANDOM
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_SETREADMODE, &mode);
			printf("SDRAM total size = %d MBytes\n", (PhysMemSize / (1024 * 1024)) * 4);
 

			ULONG addr = 0;
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_SETSTARTADDR, &addr); // set address for write
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_SETREADADDR, &addr);  // set address for read

			ULONG mem_size = g_SizeInputBuf >> 2; // set size activ zone (U32)
			status = BRD_ctrl(g_hCaptSrv[iSrv], 0, BRDctrl_SDRAM_SETMEMSIZE, &mem_size);
/*
			g_SizeInputBuf = mem_size << 2;		 // get size activ zone (bytes)

			g_ExamParam.SamplesPerChannel=g_SizeInputBuf/g_NumChans/4;
			if(g_AdmParam.AdmMode==0)g_SizeInputBuf *=2;

			if(BRD_errcmp(status, BRDerr_OK))
			{
				return true;
			}
			else
			{
				DisplayError(status, "BRDctrl_SDRAM_SETMEMSIZE");
				return false;
			}
*/
	return true;
		}
}
//******************************************************************************
 //=**********************    DDC (*.prg)****************
//=*****************************************************************************
int  ReadPrgFile( TCHAR *filename, U32* dst, PDDC_PARAM pParam ,int maxsize)
{
    FILE    *stream;
	unsigned		page, adr, data;
	int		ind=0,type;
    char    *endptr;

	stream = fopen( filename, "rt" );
    if( stream == NULL)return -1;

	fgets( g_str, 80, stream );
    fgets( g_str, 80, stream );
    type= atoi(g_str+14);
    fgets( g_str, 80, stream );
	pParam->ClockValue = atoi(g_str+7);
    fgets( g_str, 80, stream );
	pParam->ModeOfDdc = atoi(g_str+11);
	fgets( g_str, 80, stream );
	pParam->MaskAdc = strtoul( g_str+9, &endptr, 0 );
	fgets( g_str, 80, stream );
	fgets( g_str, 80, stream );
	pParam->MaskChannels = strtoul( g_str+6, &endptr, 0 );
	fgets( g_str, 80, stream );
	pParam->Decimation[0] = atoi(g_str+16);
    fgets( g_str, 80, stream );
	pParam->Decimation[1] = atoi(g_str+16);
    fgets( g_str, 80, stream );
	pParam->Decimation[2] = atoi(g_str+16);
    fgets( g_str, 80, stream );
	pParam->Decimation[3] = atoi(g_str+16);

	fgets( g_str, 80, stream );
	pParam->Fc[0] = atoi(g_str+10);
	fgets( g_str, 80, stream );
	pParam->Fc[1] = atoi(g_str+10);
	fgets( g_str, 80, stream );
	pParam->Fc[2] = atoi(g_str+10);
	fgets( g_str, 80, stream );
	pParam->Fc[3] = atoi(g_str+10);

    fgets( g_str, 80, stream );
	pParam->AdcChan[0] = atoi(g_str+9);
    fgets( g_str, 80, stream );
	pParam->AdcChan[1] = atoi(g_str+9);
    fgets( g_str, 80, stream );
	pParam->AdcChan[2] = atoi(g_str+9);
    fgets( g_str, 80, stream );
	pParam->AdcChan[3] = atoi(g_str+9);

    fgets( g_str, 80, stream );
    while( 1 )
    {
        fgets( g_str, 80, stream );
       	page = strtoul( g_str, &endptr, 0 );
       	adr  = strtoul( endptr, &endptr, 0 );
       	data = strtoul( endptr, &endptr, 0 );
       	dst[ind] = ((page&0xff)<<24) | ((adr&0xff)<<16) | (data&0xffff);
		if( (ind>0) & (dst[ind] == dst[ind-1]) )
			break;	// End of File
        ind++;
		if( ind>=maxsize )
			break;

     }
	return	ind;
}

//************************    ISVI  ******************************************
//****************************************************************************
//=*******************    DDC  ISVI *******************
//=***************************************************************************

int  WriteFileISVI_Ddc(U32 *src)
{
    int fl,rr,i,nWords,nChans=0;
    float    shift[32],gain[32],sample_rate;
    int chan[32];
    int NumOpenChansISVI=0;
    FILE *stream;
    int j=0;
	for(i=0;i<32;i++){shift[i]=0; chan[i]=0;  gain[i]=1.0;}

	for(int iSrv=0;iSrv<g_nCaptSrv;iSrv++)
	{
		if(g_DdcParam.ModeOfDdc==0)			// full rate
		{
			for(U32 i=0;i<g_NumChans;i++)
				shift[i+iSrv*g_NumChans]=(float)g_DdcParam.Fc[i%4];
		}
		if(g_DdcParam.ModeOfDdc>0)			// splitIQ, Double rate
		{
			for(U32 i=0;i<g_NumChans;i++)
				shift[i+iSrv*g_NumChans]=(float)g_DdcParam.Fc[i%2];
		}
	
		for( i=0; i<4; i++ )
		{
			if( g_DdcParam.MaskChannels & (1<<i) )
			{
				chan[2*nChans] = 2*i+2*g_NumChans*iSrv;
				chan[2*nChans+1] = 2*i+1+2*g_NumChans*iSrv;
				nChans++;
			}
		}
	}
	sample_rate=(float)g_DdcParam.ClockValue/g_DdcParam.Decimation[0];
    nWords=g_SizeInputBuf*g_nCaptSrv;
	nChans *=2;
    fl=open("data.bin", O_RDWR|O_BINARY |O_CREAT |O_TRUNC ,S_IWRITE|S_IREAD);
    write(fl,src,nWords);
    close(fl);
    stream=fopen("data.bin","a+t");
    fprintf(stream, "\nDEVICE_NAME_________ ADMDDC214x400M_DDC");
    fprintf(stream, "\nNUMBER_OF_CHANNELS__ %ld",nChans);
    fprintf(stream, "\nNUMBERS_OF_CHANNELS_ ");
                            for(i=0;i<nChans;i++)fprintf(stream,"%ld,",chan[i]);
    fprintf(stream, "\nNUMBER_OF_SAMPLES___ %d",g_ExamParam.SamplesPerChannel);
    fprintf(stream, "\nSAMPLING_RATE_______ %f",sample_rate);
    fprintf(stream, "\nBYTES_PER_SAMPLES___ 2" );
    fprintf(stream,"\nSAMPLES_PER_BYTES___ 1");
    fprintf(stream,"\nIS_COMPLEX_SIGNAL?__ ");
    fprintf(stream,"YES");
    fprintf(stream,"\nSHIFT_FREQUENCY_____ ");
                            for(i=0;i<nChans/2;i++)fprintf(stream,"%.1f,%.1f,",shift[i],shift[i]);

    fprintf(stream,"\nGAINS_______________ ");
                                for(i=0;i<nChans/2;i++)fprintf(stream,"%.1f,%.1f,",gain[i],gain[i]);
    fprintf(stream, "\nVOLTAGE_OFFSETS_____ ");
                                for(i=0;i<nChans;i++)fprintf(stream,"0.0,");
    fprintf(stream,"\nVOLTAGE_RANGE_______ 0.5" );
    fprintf(stream,"\nBIT_RANGE___________ %d",16 );
    fprintf(stream,"\n" );

    fclose(stream);

    if(SetISVI==1)
	{
        WriteFlagSinc(0xffffffff,0xffffffff);

    }else
	{
        WriteFlagSinc(0xffffffff,0x0);
    }

     for(i=0;i<0x10000;i++)
     {
		rr=ReadFlagSinc();
		if( rr==0 )
		{   SetISVI=0;
			return 1;
		}
	 }

    return 0;

}
//****************************************************************************
//=*******************      ISVI *******************
//=***************************************************************************
int  WriteFileISVI_Adc(U32 *src)
{
    int fl,rr,i,nWords,nChans=0;
    float    shift[16],gain[16],sample_rate;
    int chan[16];
    int NumOpenChansISVI=0;
    FILE *stream;
    int j=0;
	for(i=0;i<16;i++){shift[i]=0; chan[i]=0;  gain[i]=1.0;}

	for(int iSrv=0;iSrv<g_nCaptSrv;iSrv++)
	{
		for( i=0; i<4; i++ )
		{
			if( g_AdmParam.MaskChannels & (1<<i) )
			{
				chan[nChans] = i+g_NumChans*iSrv;
				nChans++;
			}
		}
	}
	sample_rate=(float)g_AdmParam.ClockValue;
    nWords=g_SizeInputBuf*g_nCaptSrv;
    fl=open("data.bin", O_RDWR|O_BINARY |O_CREAT |O_TRUNC ,S_IWRITE|S_IREAD);
    write(fl,src,nWords);
    close(fl);
    stream=fopen("data.bin","a+t");
    fprintf(stream, "\nDEVICE_NAME_________ ADMDDC214x400M_ADC");
    fprintf(stream, "\nNUMBER_OF_CHANNELS__ %ld",nChans);
    fprintf(stream, "\nNUMBERS_OF_CHANNELS_ ");
                            for(i=0;i<nChans;i++)fprintf(stream,"%ld,",chan[i]);
    fprintf(stream, "\nNUMBER_OF_SAMPLES___ %d",g_ExamParam.SamplesPerChannel);
    fprintf(stream, "\nSAMPLING_RATE_______ %f",sample_rate);
    fprintf(stream, "\nBYTES_PER_SAMPLES___ 2" );
    fprintf(stream,"\nSAMPLES_PER_BYTES___ 1");
    fprintf(stream,"\nIS_COMPLEX_SIGNAL?__ ");
    fprintf(stream,"NO");
    fprintf(stream,"\nSHIFT_FREQUENCY_____ ");
                            for(i=0;i<nChans;i++)fprintf(stream,"%.1f,",shift[i]);

    fprintf(stream,"\nGAINS_______________ ");
                                for(i=0;i<nChans;i++)fprintf(stream,"%.1f,",gain[i]);
    fprintf(stream, "\nVOLTAGE_OFFSETS_____ ");
                                for(i=0;i<nChans;i++)fprintf(stream,"0.0,");
    fprintf(stream,"\nVOLTAGE_RANGE_______ 0.5" );
    fprintf(stream,"\nBIT_RANGE___________ %d",16 );
    fprintf(stream,"\n" );

    fclose(stream);
    if(SetISVI==1)
	{
        WriteFlagSinc(0xffffffff,0xffffffff);
    }else
	{
        WriteFlagSinc(0xffffffff,0x0);
    }
     for(i=0;i<0x10000;i++)
     {
		rr=ReadFlagSinc();
		if( rr==0 )
		{	
	        SetISVI=0;
			return 1;
		}
	 }
        return 0;

}


//=**********************      *****************************************
//***********************************************************************************************
void WriteFlagSinc(int flg, int isNewParam)
{
    int fs;
    int val[2];

    errno_t err = _sopen_s( &fs, "data.flg", _O_WRONLY|_O_BINARY|_O_CREAT, _SH_DENYNO, S_IWRITE );
    val[0]=flg;
    val[1]=isNewParam;
    _write(fs,val,8);
    _close(fs);
}
//=**********************      ******************************************
//*************************************************************************************************
int ReadFlagSinc(void)
{
    int fs,flg;
    errno_t err = _sopen_s( &fs, "data.flg", _O_RDONLY|_O_BINARY|_O_CREAT, _SH_DENYNO, S_IREAD );
   _read(fs,&flg,4);
	_close(fs);
    return flg;
}

//=***********************************************************************************************

// End of file
//
